Index: /trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/ClientAdapter.cs
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/ClientAdapter.cs	(revision 970)
+++ /trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/ClientAdapter.cs	(revision 971)
@@ -57,4 +57,16 @@
 
         return clientGroupAdapter;
+      }
+    }
+
+    private IJobAdapter jobAdapter = null;
+
+    private IJobAdapter JobAdapter {
+      get {
+        if (jobAdapter == null) {
+          jobAdapter = ServiceLocator.GetJobAdapter();
+        }
+
+        return jobAdapter;
       }
     }
@@ -183,4 +195,24 @@
         return null;
       }
+    }
+
+    public ClientInfo GetClientByName(string name) {
+      ClientInfo client = new ClientInfo();
+
+      Resource res =
+        ResAdapter.GetResourceByName(name);
+
+      if (res != null) {
+        dsHiveServer.ClientRow row =
+          data.FindByResourceId(res.ResourceId);
+
+        if (row != null) {
+          Convert(row, client);
+
+          return client;
+        }
+      }
+
+      return null;
     }
 
@@ -211,7 +243,7 @@
 
         if (row != null) {
+          //Referential integrity with client groups
           ICollection<ClientGroup> clientGroups =
             ClientGroupAdapter.MemberOf(client);
-
           foreach (ClientGroup group in clientGroups) {
             group.Resources.Remove(client);
@@ -219,4 +251,11 @@
           }
 
+          //Referential integrity with jobs
+          ICollection<Job> jobs =
+            JobAdapter.GetJobsOf(client);
+          foreach (Job job in jobs) {
+            JobAdapter.DeleteJob(job);
+          }
+
           data.RemoveClientRow(row);
 
Index: /trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/ClientGroupAdapter.cs
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/ClientGroupAdapter.cs	(revision 970)
+++ /trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/ClientGroupAdapter.cs	(revision 971)
@@ -46,5 +46,5 @@
     private IResourceAdapter resourceAdapter = null;
 
-    private IResourceAdapter ResourceAdapter {
+    private IResourceAdapter ResAdapter {
       get {
         if (resourceAdapter == null)
@@ -81,5 +81,5 @@
         /*Parent - Permission Owner*/
         clientGroup.ResourceId = row.ResourceId;
-        ResourceAdapter.GetResourceById(clientGroup);
+        ResAdapter.GetResourceById(clientGroup);
 
         //first check for created references
@@ -218,5 +218,5 @@
     public void UpdateClientGroup(ClientGroup group) {
       if (group != null) {
-        ResourceAdapter.UpdateResource(group);
+        ResAdapter.UpdateResource(group);
 
         dsHiveServer.ClientGroupRow row =
@@ -246,4 +246,24 @@
         return null;
       }
+    }
+
+    public ClientGroup GetClientGroupByName(string name) {
+      ClientGroup group = new ClientGroup();
+
+      Resource res =
+        ResAdapter.GetResourceByName(name);
+
+      if (res != null) {
+        dsHiveServer.ClientGroupRow row =
+          data.FindByResourceId(res.ResourceId);
+
+        if (row != null) {
+          Convert(row, group);
+
+          return group;
+        }
+      }
+
+      return null;
     }
 
@@ -309,5 +329,5 @@
 
           data.RemoveClientGroupRow(row);
-          return ResourceAdapter.DeleteResource(group);
+          return ResAdapter.DeleteResource(group);
         }
       }
Index: /trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/HeuristicLab.Hive.Server.ADODataAccess.csproj
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/HeuristicLab.Hive.Server.ADODataAccess.csproj	(revision 970)
+++ /trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/HeuristicLab.Hive.Server.ADODataAccess.csproj	(revision 971)
@@ -4,5 +4,5 @@
     <Configuration Condition=" '$(Configuration)' == '' ">Debug</Configuration>
     <Platform Condition=" '$(Platform)' == '' ">AnyCPU</Platform>
-    <ProductVersion>9.0.21022</ProductVersion>
+    <ProductVersion>9.0.30729</ProductVersion>
     <SchemaVersion>2.0</SchemaVersion>
     <ProjectGuid>{715A9134-B6E4-4CB9-8A5A-E6601497565A}</ProjectGuid>
@@ -77,4 +77,5 @@
     </Compile>
     <Compile Include="HiveServerADODataAccessPlugin.cs" />
+    <Compile Include="JobAdapter.cs" />
     <Compile Include="PermissionOwnerAdapter.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
Index: /trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/JobAdapter.cs
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/JobAdapter.cs	(revision 971)
+++ /trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/JobAdapter.cs	(revision 971)
@@ -0,0 +1,253 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Hive.Server.Core.InternalInterfaces.DataAccess;
+using HeuristicLab.Hive.Contracts.BusinessObjects;
+using System.Linq.Expressions;
+using System.Runtime.CompilerServices;
+
+namespace HeuristicLab.Hive.Server.ADODataAccess {
+  class JobAdapter : DataAdapterBase, IJobAdapter {
+    private dsHiveServerTableAdapters.JobTableAdapter adapter =
+        new dsHiveServerTableAdapters.JobTableAdapter();
+
+    private dsHiveServer.JobDataTable data =
+      new dsHiveServer.JobDataTable();
+
+    private IClientAdapter clientAdapter = null;
+
+    private IClientAdapter ClientAdapter {
+      get {
+        if (clientAdapter == null)
+          clientAdapter = ServiceLocator.GetClientAdapter();
+
+        return clientAdapter;
+      }
+    }
+
+    private IUserAdapter userAdapter = null;
+
+    private IUserAdapter UserAdapter {
+      get {
+        if (userAdapter == null) {
+          userAdapter = ServiceLocator.GetUserAdapter();
+        }
+
+        return userAdapter;
+      }
+    }
+
+    public JobAdapter() {
+      adapter.Fill(data);
+    }
+
+    protected override void Update() {
+      this.adapter.Update(this.data);
+    }
+
+    private Job Convert(dsHiveServer.JobRow row,
+      Job job) {
+      if (row != null && job != null) {
+        job.JobId = row.JobId;
+
+        if (!row.IsParentJobIdNull())
+          job.parentJob = GetJobById(row.ParentJobId);
+        else
+          job.parentJob = null;
+
+        if (!row.IsResourceIdNull())
+          job.Client = ClientAdapter.GetClientById(row.ResourceId);
+        else
+          job.Client = null;
+        
+        if (!row.IsStatusNull())
+          job.State = (State)Enum.Parse(job.State.GetType(), row.Status);
+        else
+          job.State = State.idle;
+
+        return job;
+      } else
+        return null;
+    }
+
+    private dsHiveServer.JobRow Convert(Job job,
+      dsHiveServer.JobRow row) {
+      if (job != null && row != null) {
+        if (job.Client != null) {
+          ClientAdapter.UpdateClient(job.Client);
+          row.ResourceId = job.Client.ResourceId;
+        } else
+          row.SetResourceIdNull();
+
+        if (job.parentJob != null) {
+          UpdateJob(job.parentJob);
+          row.ParentJobId = job.parentJob.JobId;
+        } else
+          row.SetParentJobIdNull();
+
+        row.Status = job.State.ToString();
+      }
+
+      return row;
+    }
+
+    #region IJobAdapter Members
+    [MethodImpl(MethodImplOptions.Synchronized)]
+    public void UpdateJob(Job job) {
+      if (job != null) {
+        dsHiveServer.JobRow row =
+          data.FindByJobId(job.JobId);
+
+        if (row == null) {
+          row = data.NewJobRow();
+          data.AddJobRow(row);
+
+          //write row to db to get primary key
+          adapter.Update(row);
+        }
+
+        Convert(job, row);
+        job.JobId = row.JobId;
+      }
+    }
+
+    public Job GetJobById(long id) {
+      dsHiveServer.JobRow row =
+        data.FindByJobId(id);
+
+      if (row != null) {
+        Job job = new Job();
+        
+        Convert(row, job);
+
+        return job;
+      }
+
+      return null;
+    }
+
+    public ICollection<Job> GetAllJobs() {
+      IList<Job> allJobs =
+        new List<Job>();
+
+      foreach (dsHiveServer.JobRow row in data) {
+        Job job = new Job();
+        Convert(row, job);
+        allJobs.Add(job);
+      }
+
+      return allJobs;
+    }
+
+    public ICollection<Job> GetAllSubjobs(Job job) {
+      IList<Job> allJobs =
+        new List<Job>();
+
+      if (job != null) {
+        IEnumerable<dsHiveServer.JobRow> clientJobs =
+         from j in
+           data.AsEnumerable<dsHiveServer.JobRow>()
+         where j.ParentJobId == job.JobId
+         select j;
+
+        foreach (dsHiveServer.JobRow row in
+          clientJobs) {
+          Job j = new Job();
+          Convert(row, j);
+          allJobs.Add(j);
+        }
+      }
+
+      return allJobs;
+    }
+
+    public JobResult GetResult(Job job) {
+      throw new NotImplementedException();
+    }
+
+    public ICollection<Job> GetJobsOf(ClientInfo client) {
+      IList<Job> allJobs =
+        new List<Job>();
+
+      if (client != null) {
+        IEnumerable<dsHiveServer.JobRow> clientJobs =
+         from job in
+           data.AsEnumerable<dsHiveServer.JobRow>()
+         where job.ResourceId == client.ResourceId
+         select job;
+
+        foreach (dsHiveServer.JobRow row in
+          clientJobs) {
+          Job job = new Job();
+          Convert(row, job);
+          allJobs.Add(job);
+        }
+      }
+
+      return allJobs;
+    }
+
+    public ICollection<Job> GetJobsOf(User user) {
+      IList<Job> allJobs =
+        new List<Job>();
+
+      if (user != null) {
+        IEnumerable<dsHiveServer.JobRow> userJobs =
+        from job in
+          data.AsEnumerable<dsHiveServer.JobRow>()
+        where job.PermissionOwnerId == user.PermissionOwnerId
+        select job;
+
+        foreach (dsHiveServer.JobRow row in
+          userJobs) {
+          Job job = new Job();
+          Convert(row, job);
+          allJobs.Add(job);
+        }
+      }
+
+      return allJobs;
+    }
+
+    [MethodImpl(MethodImplOptions.Synchronized)]
+    public bool DeleteJob(Job job) {
+      if (job != null) {
+        dsHiveServer.JobRow row =
+          data.FindByJobId(job.JobId);
+
+        if (row != null) {
+          row.Delete();
+          adapter.Update(row);
+
+          return true;
+        }
+      }
+
+      return false;
+    }
+
+    #endregion
+  }
+}
Index: /trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/ResourceAdapter.cs
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/ResourceAdapter.cs	(revision 970)
+++ /trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/ResourceAdapter.cs	(revision 971)
@@ -112,4 +112,20 @@
     }
 
+    public Resource GetResourceByName(string name) {
+      Resource resource = new Resource();
+
+      dsHiveServer.ResourceRow row =
+        data.Single<dsHiveServer.ResourceRow>(
+          r => !r.IsNameNull() && r.Name == name);
+
+      if (row != null) {
+        Convert(row, resource);
+
+        return resource;
+      } else {
+        return null;
+      }
+    }
+
     public ICollection<Resource> GetAllResources() {
       IList<Resource> allResources =
Index: /trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/UserAdapter.cs
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/UserAdapter.cs	(revision 970)
+++ /trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/UserAdapter.cs	(revision 971)
@@ -57,4 +57,16 @@
 
         return userGroupAdapter;
+      }
+    }
+
+    private IJobAdapter jobAdapter = null;
+
+    private IJobAdapter JobAdapter {
+      get {
+        if (jobAdapter == null) {
+          jobAdapter = ServiceLocator.GetJobAdapter();
+        }
+
+        return jobAdapter;
       }
     }
@@ -170,7 +182,7 @@
 
         if (row != null) {
+          //Referential integrity with user groups
           ICollection<UserGroup> userGroups =
             UserGroupAdapter.MemberOf(user);
-
           foreach (UserGroup group in userGroups) {
             group.Members.Remove(user);
@@ -178,4 +190,11 @@
           }
 
+          //Referential integrity with jobs
+          ICollection<Job> jobs =
+            JobAdapter.GetJobsOf(user);
+          foreach (Job job in jobs) {
+            JobAdapter.DeleteJob(job);
+          }
+
           data.RemoveHiveUserRow(row);
 
Index: /trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/UserGroupAdapter.cs
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/UserGroupAdapter.cs	(revision 970)
+++ /trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/UserGroupAdapter.cs	(revision 971)
@@ -248,4 +248,24 @@
     }
 
+    public UserGroup GetUserGroupByName(string name) {
+      UserGroup group = new UserGroup();
+
+      PermissionOwner permOwner =
+        PermOwnerAdapter.GetPermissionOwnerByName(name);
+
+      if (permOwner != null) {
+        dsHiveServer.UserGroupRow row =
+          data.FindByPermissionOwnerId(permOwner.PermissionOwnerId);
+
+        if (row != null) {
+          Convert(row, group);
+
+          return group;
+        }
+      }
+
+      return null;
+    }
+
     public ICollection<UserGroup> GetAllUserGroups() {
       ICollection<UserGroup> allUserGroups =
